package com.ruoyi.zhushi.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.system.domain.ZsBanner;
import com.ruoyi.zhushi.entity.DkCheckInConfig;
import com.ruoyi.zhushi.entity.DkCheckInConfigDTO;
import com.ruoyi.zhushi.entity.DkCheckInRecord;
import com.ruoyi.zhushi.entity.DkCheckInRecordDTO;
import com.ruoyi.zhushi.mapper.DkConfigMapper;
import com.ruoyi.zhushi.mapper.DkMapper;
import com.ruoyi.zhushi.service.DkConfigService;
import com.ruoyi.zhushi.service.DkService;
import com.ruoyi.zhushi.util.TimeUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class DkConfigServiceImpl implements DkConfigService {


    @Autowired
    private DkConfigMapper dkConfigMapper;


    @Override
    public List<DkCheckInConfigDTO> queryList() {
        List<DkCheckInConfig> dkCheckInConfigs = dkConfigMapper.selectList();
        List<DkCheckInConfigDTO> dkCheckInConfigDTOS = dkCheckInConfigs.stream()
            .map(dkCheckInConfig -> {
                DkCheckInConfigDTO dkCheckInConfigDTO = new DkCheckInConfigDTO();
                dkCheckInConfigDTO.setId(dkCheckInConfig.getId());
                dkCheckInConfigDTO.setName(dkCheckInConfig.getName());
                dkCheckInConfigDTO.setRadius(dkCheckInConfig.getRadius());
                dkCheckInConfigDTO.setEnableStatus(dkCheckInConfig.getEnableStatus());
                dkCheckInConfigDTO.setLng(dkCheckInConfig.getLng());
                dkCheckInConfigDTO.setLat(dkCheckInConfig.getLat());
                // 这里需要返回DTO对象
                return dkCheckInConfigDTO;
            })
            .collect(Collectors.toList());

        // 返回转换后的DTO列表，而不是null
        return dkCheckInConfigDTOS;
    }

    @Override
    public boolean addConfig(DkCheckInConfigDTO dkCheckInConfigDTO) {
        DkCheckInConfig dkCheckInConfig = BeanUtil.toBean(dkCheckInConfigDTO, DkCheckInConfig.class);
//        DkCheckInConfig dkCheckInConfig = new DkCheckInConfig();
//        dkCheckInConfig.setAreaName(dkCheckInConfigDTO.getAreaName());
//        dkCheckInConfig.setCheckInRadious(dkCheckInConfigDTO.getCheckInRadious());
//        dkCheckInConfig.setEnableStatus(dkCheckInConfigDTO.getEnableStatus());
//        dkCheckInConfig.setLatitude(dkCheckInConfigDTO.getLatitude());
//        dkCheckInConfig.setLongitude(dkCheckInConfigDTO.getLongitude());
//        dkCheckInConfig.setCreateTime(new Date());
//        dkCheckInConfig.setUpdateTime(new Date());
//        dkCheckInConfig.setCreateBy(dkCheckInConfigDTO.getCreateBy());
        return dkConfigMapper.insertOrUpdate(dkCheckInConfig);
    }

    @Override
    public int deleteConfig(long id) {
        return dkConfigMapper.deleteById(id);
    }

    @Override
    public int updateConfig(DkCheckInConfigDTO dkCheckInConfigDTO) {
        DkCheckInConfig dkCheckInConfig = new  DkCheckInConfig();
        dkCheckInConfig.setId(dkCheckInConfigDTO.getId());
        dkCheckInConfig.setEnableStatus(dkCheckInConfigDTO.getEnableStatus());
        return dkConfigMapper.updateById(dkCheckInConfig);
    }
}
